Imports Syncfusion.Windows.Forms.Grid

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents GridDataBoundGrid1 As Syncfusion.Windows.Forms.Grid.GridDataBoundGrid
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.GridDataBoundGrid1 = New Syncfusion.Windows.Forms.Grid.GridDataBoundGrid()
        Me.Button1 = New System.Windows.Forms.Button()
        Me.Button2 = New System.Windows.Forms.Button()
        CType(Me.GridDataBoundGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'GridDataBoundGrid1
        '
        Me.GridDataBoundGrid1.AllowDragSelectedCols = True
        Me.GridDataBoundGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.GridDataBoundGrid1.Location = New System.Drawing.Point(8, 48)
        Me.GridDataBoundGrid1.Name = "GridDataBoundGrid1"
        Me.GridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus
        Me.GridDataBoundGrid1.Size = New System.Drawing.Size(516, 316)
        Me.GridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick
        Me.GridDataBoundGrid1.TabIndex = 0
        Me.GridDataBoundGrid1.Text = "GridDataBoundGrid1"
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(104, 8)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(104, 23)
        Me.Button1.TabIndex = 1
        Me.Button1.Text = "Load Grid"
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(288, 8)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(104, 23)
        Me.Button2.TabIndex = 2
        Me.Button2.Text = "ResetGrid"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(536, 374)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Button2, Me.Button1, Me.GridDataBoundGrid1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.GridDataBoundGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
       
    End Sub

    Private Function GetParentTable() As DataTable
        Dim dt As New DataTable("ParentTable")

        Dim nRows As Integer = 5

        dt.Columns.Add(New DataColumn("parentID")) 'lower case p
        dt.Columns.Add(New DataColumn("ParentName"))

        Dim i As Integer

        While i < nRows
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i.ToString()
            dr(1) = String.Format("parentName{0}", i)
            dt.Rows.Add(dr)
            i += 1
        End While

        Return dt
    End Function 'GetParentTable

    Private Function GetChildTable() As DataTable
        Dim dt As New DataTable("ChildTable")

        dt.Columns.Add(New DataColumn("childID")) 'lower case c
        dt.Columns.Add(New DataColumn("Name"))
        dt.Columns.Add(New DataColumn("ParentID")) 'upper case P
        Dim i As Integer

        While i < 20
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i.ToString()
            dr(1) = String.Format("ChildName{0}", i)
            dr(2) = (i Mod 5).ToString()
            dt.Rows.Add(dr)
            i += 1
        End While

        Return dt
    End Function 'GetChildTable


    Private Function GetGrandChildTable() As DataTable
        Dim dt As New DataTable("GrandChildTable")

        dt.Columns.Add(New DataColumn("GrandChildID"))
        dt.Columns.Add(New DataColumn("Name"))
        dt.Columns.Add(New DataColumn("ChildID")) 'upper case C
        Dim i As Integer

        While i < 50
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i.ToString()
            dr(1) = String.Format("GrandChildName{0}", i)
            dr(2) = (i Mod 20).ToString()
            dt.Rows.Add(dr)
            i += 1
        End While

        Return dt
    End Function 'GetGrandChildTable

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim dSet As New DataSet()

        'get the tables
        Dim parentTable As DataTable = GetParentTable()
        '			dSet.Tables.Add(parentTable);
        Dim childTable As DataTable = GetChildTable()
        '			dSet.Tables.Add(childTable);
        Dim grandChildTable As DataTable = GetGrandChildTable()
        dSet.Tables.AddRange(New DataTable() {parentTable, childTable, grandChildTable})

        'setup the relations
        Dim parentColumn As DataColumn = parentTable.Columns("parentID")
        Dim childColumn As DataColumn = childTable.Columns("ParentID")

        dSet.Relations.Add("ParentToChild", parentColumn, childColumn)

        parentColumn = childTable.Columns("childID")
        childColumn = grandChildTable.Columns("ChildID")

        dSet.Relations.Add("ChildToGrandChild", parentColumn, childColumn)

        Me.GridDataBoundGrid1.BeginUpdate()

        'set the grids
        If Not Me.GridDataBoundGrid1.DataSource Is Nothing Then
            Me.Button2.PerformClick()
        End If

        Me.GridDataBoundGrid1.DataSource = parentTable

        Dim level0 As GridHierarchyLevel = Me.GridDataBoundGrid1.Binder.RootHierarchyLevel()
        level0.RowStyle.BackColor = Color.LightSkyBlue

        Dim level1 As GridHierarchyLevel = Me.GridDataBoundGrid1.Binder.AddRelation("ParentToChild")
        level1.RowStyle.BackColor = Color.LightGoldenrodYellow
        Dim level2 As GridHierarchyLevel = Me.GridDataBoundGrid1.Binder.AddRelation("ChildToGrandChild")
        'level2.RowStyle.BackColor = Color.LightSkyBlue


        Me.GridDataBoundGrid1.AllowResizeToFit = False
        Me.GridDataBoundGrid1.Model.ColWidths.ResizeToFit(GridRangeInfo.Rows(0, 2))
        Me.GridDataBoundGrid1.Model.ColWidths(3) = 140

        Me.GridDataBoundGrid1.ExpandAll()

        Me.GridDataBoundGrid1.EndUpdate()

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.GridDataBoundGrid1.DataSource = Nothing
        Me.GridDataBoundGrid1.Binder.ResetHierarchyLevels()
        Me.GridDataBoundGrid1.Refresh()
    End Sub
End Class


